unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SynaSer, StdCtrls, ExtCtrls, Menus, Unit2;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    comName: TEdit;
    baudrate: TEdit;
    connectButton: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Forward: TButton;
    Stop: TButton;
    disconnectButton: TButton;
    Backward: TButton;
    Right: TButton;
    Left: TButton;
    MainMenu1: TMainMenu;
    xzcxzcxz: TMenuItem;
    Exit1: TMenuItem;
    GroupBox3: TGroupBox;
    About1: TMenuItem;
    procedure connectButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ForwardClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure disconnectButtonClick(Sender: TObject);
    procedure LeftClick(Sender: TObject);
    procedure RightClick(Sender: TObject);
    procedure BackwardClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure About1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  connected: boolean;
  ser: TBlockSerial;
  stopped: boolean;
  sensor: integer;

const
  APP_VERSION = 'v1.0';

implementation

{$R *.DFM}

(**
 * sends command to serial port
 *)
procedure sendCommand(command: string);
var rec: string;
    h, l, res: integer;
begin
  if (command = 'SS') then begin
    stopped := true;
  end else begin
    stopped := false;
  end;

  if connected = true then begin
    try
    ser.SendString(command+chr(13)+chr(10));
    rec := ser.RecvPacket(10);

    finally
    //ser.free;
  end;
  end;
end;

(**
 * connect the com port
 *)
procedure TForm1.connectButtonClick(Sender: TObject);
begin
  ser := TBlockSerial.Create;
  ser.RaiseExcept := false; // do not throw exceptions (maybe dirty hack, but the library used to raise exceptions any time :-) )

  try
    ser.Connect(comName.Text);
    ser.Config(strToInt(baudrate.Text), 8, 'N', 0, false, false);

    // enable/disable buttons when connected
    connected := true;
    connectButton.Enabled := false;
    disconnectButton.Enabled := true;
    left.Enabled := true;
    right.Enabled := true;
    forward.Enabled := true;
    backward.Enabled := true;
    stop.Enabled := true;


  finally
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  connected := false;
  stopped := true;
  Form1.Caption := Form1.Caption+' '+APP_VERSION;
  sensor := 0;
end;

procedure TForm1.ForwardClick(Sender: TObject);
begin
sendCommand('FF');
end;

procedure TForm1.StopClick(Sender: TObject);
begin
sendCommand('SS');
stopped := true;
end;

procedure TForm1.disconnectButtonClick(Sender: TObject);
begin
  try
    // disable/enable buttons when disconnecting
    connected := false;
    connectButton.Enabled := true;
    disconnectButton.Enabled := false;
    left.Enabled := false;
    right.Enabled := false;
    forward.Enabled := false;
    backward.Enabled := false;
    stop.Enabled := false;



    // free COM connection
    ser.Free;
  finally
  end;
end;

procedure TForm1.LeftClick(Sender: TObject);
begin
  sendCommand('BF');
end;

procedure TForm1.RightClick(Sender: TObject);
begin
  sendCommand('FB');
end;

procedure TForm1.BackwardClick(Sender: TObject);
begin
  sendCommand('BB');
  stopped := false;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Application.Terminate;
end;

(**
 * key control
 *)
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//memo1.Lines.text := memo1.lines.Text+FloatToStr(key)+' ';
case (key) of
  38: sendCommand('FF'); // forward
  40: if (stopped) then sendCommand('BB') else sendCommand('SS'); // stop
  37: sendCommand('BF'); // left
  39: sendCommand('FB'); // right
end;
end;


(**
 * shows 'About' forma
 *)
procedure TForm1.About1Click(Sender: TObject);
begin
    aboutForm.Show;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
sendCommand('T'+chr(50));
end;




end.


