
 
// "_"" means private :-)
#define _leftStop() { PORTD &= ~(1<<PD2); PORTD &= ~(1<<PD3); }
#define _leftBack() { PORTD |= (1<<PD2); PORTD &= ~(1<<PD3); }
#define _leftGo() { PORTD |= (1<<PD3); PORTD &= ~(1<<PD2); }

#define _rightStop() { PORTD &= ~(1<<PD6); PORTD &= ~(1<<PD7); }
#define _rightGo() { PORTD |= (1<<PD6); PORTD &= ~(1<<PD7); }
#define _rightBack() { PORTD |= (1<<PD7); PORTD &= ~(1<<PD6); }


volatile int mSpeedMax = 405;

  
int limitSpeed(int speed) {  
  int limit;
  
  if (mSpeedMax == HIGH_SPEED) {
    limit = HIGH_SPEED;
  } else {
    limit = LOW_SPEED-HIGH_SPEED;
  }
    
  if (speed > limit) {
    speed = limit;
  } else if (speed < -limit) {
    speed = -limit;
  }
  
  return speed;
}             
  
void leftSpeed(int speed) {
  speed = limitSpeed(speed);
  
  if (speed == 0) {
    _leftStop();
  } else if (speed > 0) {
    _leftGo();
    OCR1A = mSpeedMax-speed;
  } else {
    _leftBack();
    OCR1A = mSpeedMax+speed;
  }
}
  
void rightSpeed(int speed) {
  speed = limitSpeed(speed);
  
  if (speed == 0) {
    _rightStop();
  } else if (speed > 0) {
    _rightGo();
    OCR1B = mSpeedMax-speed;
  } else {
    _rightBack();
    OCR1B = mSpeedMax+speed;
  }
}
  
// set OC1A and OC1B on compare match, phase correct PWM, TOP = OCR1A, no prescaler
#define pwmInit() { TCCR1A = (1<<COM1A1) | (1<<COM1A0) | (1<<COM1B1) | (1<<COM1B0); TCCR1A |= (1<<WGM13) | (1<<WGM11) | (1<WGM10); TCCR1B |= (1<<CS10); }
  
#define motorsInit() { DDRD |= (1<<PD2) | (1<<PD3) | (1<<PD4) | (1<<PD5) | (1<<PD6) | (1<<PD7); pwmInit(); }