#define uartPutc(c) uartTransmit(c)

/**
 * USART initialization
 */
void uartInit(unsigned int ubrr) {
  	// set baud rate
  	UBRRH = (unsigned char)(ubrr>>8);
  	UBRRL = (unsigned char)ubrr;
	// Enable receiver, transmitter and reciever interrupt
	UCSRB = (1<<RXEN)|(1<<TXEN)|(1<<RXCIE);
	// set frame format: 8 data bits, 1 stop bit, no parity */
	UCSRC = (1<<URSEL)|(3<<UCSZ0);
}

/**
 * Data receiving
 */
unsigned char uartReceive() {
	// wait for data to be received
	while ( !(UCSRA & (1<<RXC)) ) 	
		;
  	// get and return received data from buffer */
  	return UDR;
}

/**
 * Data transmiting
 */
void uartTransmit(unsigned char data) {
	/* Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE))) 
		;
	/* Put data into buffer, sends the data */
	UDR = data;
}

void uartPuts(char *txt) {
  while(*txt) {
    uartTransmit(*txt);
    txt++;
  }
}

void uartPuti(int i) {
  char buffer[10];
  itoa(i, buffer, 10);
  
  uartPuts(buffer);
}