#define F_CPU 16000000  // 16 MHz

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <stdio.h>
#include <stdlib.h>

#include "board.h"


int main (void) {	
	initBoard(); // init hardware (GPIO, Timers, Interrupts, ADC, UART, ...)
	sei(); // enable interrupts
	_delay_ms(50); // wait some time before UART inits
	
	greenOn(); // green LED on
	
	uartPuts("\nRoboBoard\n\n"); // welcome message
  
  // SPEED - very small for 12V adapter
  setLowSpeed();
  
  // DIPSW3 == 1 => high speed (for batteries)
  if (DIPSW3) {
    setHighSpeed();
  }


  redOn();
  while (!readButton());
  redOff();
  
    int speed = 200;
     
    while (1) {
      if (BLACK(LINE3)) {
          leftSpeed(speed);
          rightSpeed(speed);
        } else if (BLACK(LINE5)) {
          leftSpeed(speed);
          rightSpeed(-speed);
        } else if (BLACK(LINE1)) {
          leftSpeed(-speed);
          rightSpeed(speed);
        } else if (BLACK(LINE4)) {
          leftSpeed(speed);
          rightSpeed(0);
        } else if (BLACK(LINE2)) {
          leftSpeed(0);
          rightSpeed(speed);
        } else {
          leftSpeed(speed);
          rightSpeed(speed);
        }      
    }

	return 0;
}

